#include <fstream>
#include <vector>
#include <cmath>
#include <utility>
#include <iostream>

#define cin fin

using namespace std;
typedef pair<int, int> Pair;

const int MAXN = 2005;
const int MAXD = 1e6 + 1;

int Stopped[MAXN], X[MAXN], Y[MAXN], T[MAXN][MAXN];
vector<Pair> Meets[MAXD];
int maxx, maxy, n, now;
long long Extend[MAXD];
vector<int> ToStop;



int getTime(int i, int j) {
    if(j == 0)
        return min(min(X[i], Y[i]), min(maxx - X[i] + 1, maxy - Y[i] + 1));

    int d = abs(X[i] - X[j]) + abs(Y[i] - Y[j]);
    if(Stopped[j] >= 0)
        return d - Stopped[j] + 1;
    return (1 + d) / 2;
}

void addEvent(int i, int j) {
    int t = getTime(i, j);
    Meets[t].push_back(make_pair(i, j));
}


int main() {
    int p, t;

    ifstream cin("civilizatie.in");
    ofstream cout("civilizatie.out");

    cin >> p;
    cin >> maxx >> maxy;
    Extend[1] = 1;
    for(int i = 2; i < MAXD; ++i)
        Extend[i] = Extend[i - 1] + 4 * i - 4;

    cin >> t;
    if(p == 1) {
        cout << Extend[t];
        return 0;
    } else {
        cin >> n;

        for(int i = 1; i <= n; ++i) {
            cin >> X[i] >> Y[i];
            Stopped[i] = -1;
        }

        for(int i = 1; i <= n; ++i)
        for(int j = n; j >= 0; --j) {
            if(i != j)
                addEvent(i, j);
        }

        int cnt = n;
        for(now = 1; cnt; ++now) {
            for(int z = 0; z < Meets[now].size(); ++z) {
                Pair p = Meets[now][z];
                if(Stopped[p.first] == -1 && now == getTime(p.first, p.second)) {
                    ToStop.push_back(p.first);
                }
            }

            for(int i = 0; i < ToStop.size(); ++i) {
                int no = ToStop[i];
                if(Stopped[no] >= 0) continue;

                Stopped[no] = now;
                --cnt;

                for(int j = 1; j <= n; ++j)
                    if(Stopped[j] == -1)
                        addEvent(j, no);
            }
            ToStop.clear();

        }

        long long ans = 1LL * maxx * maxy;
        for(int i = 1; i <= n; ++i)
            ans -= Extend[Stopped[i]];
    }


    return 0;
}
