#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long LL;

const int MAX_N = 320 + 10;
const int MAX_M = 10000 + 10;

int v[MAX_N][MAX_M];
int n, m;

int s[MAX_N][MAX_M][3];

LL ans = 0;

int vect[MAX_M][3];
//vect[i][j] -> partial sum of j over the i prefix

struct state {
  int v[3];
  //v[0] -> cnt[0] - cnt[1]
  //v[1] -> cnt[0] - cnt[2]
  //v[2] -> cnt[1] - cnt[2]

  bool operator==(const state &other) {
    for(int k = 0; k < 3; ++k)
      if(v[k] != other.v[k])
        return 0;
    return 1;
  }
};

state good = {0, 0, 0};

bool comp(const state &a, const state &b) {
  int k = 0;
  while(k < 2 && a.v[k] == b.v[k])
    k++;
  return a.v[k] < b.v[k];
}

state sts[MAX_M];

state getState(int i) {
  state ret;
  ret.v[0] = vect[i][0] - vect[i][1];
  ret.v[1] = vect[i][0] - vect[i][2];
  ret.v[2] = vect[i][1] - vect[i][2];
  return ret;
}

LL cnt(int l1, int l2) {
  for(int i = 1; i <= m; ++i) {
    for(int k = 0; k < 3; ++k) 
      vect[i][k] = vect[i - 1][k] + s[l2][i][k] - s[l1 - 1][i][k] - s[l2][i - 1][k] + s[l1 - 1][i - 1][k];
    
  }

  for(int i = 1; i <= m; ++i) 
    sts[i] = getState(i);

  sort(sts + 1, sts + m + 1, comp);

  LL ret = 0;

  for(int i = 1, j; i <= m; i = j) {
    j = i + 1;
    while(j <= m && sts[i] == sts[j])
      j++;

    LL diff = j - i;

    ret += diff * (diff - 1) / 2;
  }

  for(int i = 1; i <= m; ++i)
    ret += sts[i] == good;

  return ret;
}

int main() {
  ifstream in("omogene.in");
  ofstream out("omogene.out");

  in >> n >> m;
  for(int i = 1; i <= n; ++i) {
    for(int j = 1; j <= m; ++j) {
      in >> v[i][j];
    }
  }

  for(int i = 1; i <= n; ++i) {
    for(int j = 1; j <= m; ++j) {
      for(int k = 0; k < 3; ++k) {
        s[i][j][k] += s[i - 1][j][k] + s[i][j - 1][k] - s[i - 1][j - 1][k];
      }
      s[i][j][v[i][j]]++;
    }
  }

  for(int i = 1; i <= n; ++i) {
    for(int j = i; j <= n; ++j) {
      ans += cnt(i, j);
    }
  }
  out << ans << "\n";
  return 0;
}
